/******************************************************************************* 
 * clap_switch.c
 * 
 * Interruptor acionado por  batida de palmas
 * C/ Pic 12f675
 * 
 * Autor: Cludio Lrios
 *
 * Data: 23/11/2015
 *
 * Acionar aparelhos mediante a batida de 2 palmas p/ ligar e mais 2 para desligar
 * 
 * Use compilador CCS C
 * Uso didtico
 * Este arquivo  parte integrante do blog Lrios.Tecnologia.ws
 ******************************************************************************/

#include <12F675.h>
#device adc=8
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, NOPUT, NOBROWNOUT

//byte
#byte   ANSEL  = 0X9F
#byte   VRCON  = 0X99
#byte   GPIO   = 0X05
#byte   TRISIO = 0X85
#byte   CMCON  = 0X19
#byte   TMR1L  = 0X0E
#byte   TMR1H  = 0X0F
#byte   ANSEL  = 0X9F
#byte   T1CON  = 0X10
//bit
#bit    COUT   = 0X19.6
#bit    GPIO4  = 0X5.4 //pino 3
#bit    out    = 0x5.5//pino 2
//define
#define tempo_max 45000
#define intervalo 15000

/*******************************************************************************
           ROTINA DE DETECO DE BATIDA DE PALMAS
*******************************************************************************/
void detecta(){
     
    
     if(COUT){
           unsigned int16 time=tempo_max;
           unsigned int16 time1=intervalo;
      
           delay_ms(100);//aguarda fim da primeira batida de palmas
           GPIO4=1;//liga led para indicar 'janela' para acionamento aberta
           while((!COUT)&&(time1))time1--;//intervalo entre batidas de palma no pode ter som 
           
           if(!COUT){
           while((!COUT)&&(time))time--;//aguarda outra batida de palma
           
           if(time) out= !out;//se houver, inverte a sada
           }
           GPIO4=0;//apaga led
           delay_ms(100);  //delay        
        } //if(cout) 
 }//void detecta()



/*******************************************************************************
           ROTINA MAIN
*******************************************************************************/


void main() {

    TRISIO=0B001111;//sentido do port
    GPIO=0;//situao inicial
    CMCON=0b00000100; //0b00010100;//liga comparador c/ vref
    VRCON=0B10101000;////liga vref x/24*5   8/24*5= 1,66v
    ANSEL=0;//desliga conversor AD
    delay_ms(500);//delay inicial 

    
    for(;;){ detecta(); }//LOOP PRINCIPAL
        
    
}

