/******************************************************************************* 
 * clap_switch.c
 * 
 * Interruptor acionado por batida de palmas
 * C/ Pic 12f675
 * 
 * Autor: Cludio Lrios
 *
 * Data: 23/11/2015
 * 
 * Uso: Acionar aparelhos com uso de batida de palmas
 * 2 batidas ligar e mais 2 desligar 
 * Use XC8 Compiler junto com MplabX-Ide
 * Uso didtico
 * Este arquivo  parte integrante do blog Lrios.Tecnologia.ws
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#define _XTAL_FREQ 4000000//frequncia usada (osc.interno))

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin, I/O function on GP5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-Up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = OFF      // GP3/MCLR pin function select (GP3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)


#define  out  GPIO5  //pino 2

#define tempo_max 45000 //tempo maximo da janela de acionamento
#define intervalo 15000 //tempo do intervalo que no pode ter som 

unsigned int time,time1;

/*******************************************************************************
      Rotina de deteco de batida de palmas
 ******************************************************************************/


void detecta(){
    
     if(COUT){
           time=tempo_max;
           time1=intervalo;
           __delay_ms(100);//aguarda fim da primeira batida de palmas
           GPIO4=1;//TESTE
           while((!COUT)&&(time1))time1--;//intervalo entre batidas de palma no pode ter som 
           
           if(!COUT){
           while((!COUT)&&(time))time--;//aguarda outra batida de palma
           
           if(time) out= !out;
           }
           GPIO4=0;//TESTE
           __delay_ms(100);
           
          
        }
    
    
}


/*******************************************************************************
      Rotina Main
 ******************************************************************************/



int main(int argc, char** argv) {

    TRISIO=0B001111;//sentido do port
    GPIO=0;//situao inicial
    CMCON=0b00000100; //0b00010100;//liga comparador c/ vref
    VRCON=0B10101000;////liga vref x/24*5   8/24*5= 1,66v
    ANSEL=0;//desliga conversor AD
    __delay_ms(500);  //delay inicial  
    for(;;){  detecta();} //LOOP PRINCIPAL DE REPETIO  
            
    return (EXIT_SUCCESS);
}

